<template>
<div class="wrapper">
  
    <!-- sidebar -->
    <div class="col-2 " v-if="showSideBar"> <!-- v-if="showSideBar" -->
      <div class="sidebar right-shadow" data-color="win" data-image="../../public/assets/img/sidebar-1.jpg"> 
        <div class="logo"><a href="http://www.creative-tim.com" class="simple-text logo-normal">
            CFA Location
          </a></div>
        <div class="sidebar-wrapper">
          <ul class="nav">
            <!--  
            <li class="nav-item active  ">
              <a class="nav-link" href="./dashboard.html">
                <i class="material-icons">dashboard</i>
                <p>Dashboard</p>
              </a>
            </li>
            -->
            <div :class="{ disabled: accessLink }">
              <router-link
                @click.native="showSubpanel(link)"
                :to="link.path" v-for="(link, i) in links" :key="i">
                <li class="nav-item active mb-3">
                  <a class="nav-link" href="./dashboard.html">
                    <i :class="'fa fa-'+link.icon"></i>
                    <p>{{link.title}}</p>
                  </a>
                  <i v-if="link.children" class="fa fa-angle-right pull-right mt-1"></i>
                </li>
              </router-link>
            </div>
             
              <li class="nav-item active-pro ">
              <a class="nav-link d-flex justify-content-around" >
                <i class="material-icons" style="color: #318CE7;">facebook</i>
                <i class="material-icons" style="color: #096A09;">whatsapp</i>
                <i class="material-icons" style="color: #03224C;">infos</i>
              </a>
            </li>
          
          </ul>
        </div>
      </div>
      <div class="sidebar sub-sidebar right-shadow" v-if="this.subpanelVisible">
      <div class>
        <div class="text-right p-2 side-close">
          <i class="fa fa-times" @click="hideSubpanel()"></i>
        </div>
        <div class="side-menu">
          <router-link
            class="side-menu-link"
            @click.native="hideSubpanel()"
            :to="link.path"
            v-for="(link, i) in childLinks"
            :key="i"
          >
            <i :class="'fa fa-' + link.icon"></i>
            <span>{{link.title}}</span>
          </router-link>
        </div>
      </div>
    </div>

    </div>


    <!-- main section -->
    <div class="h-100 w-100" >
        <!-- header -->
        <div class="navtop d-flex flex-row justify-content-between menu">
          <span class="pull-left" v-if="admin"></span>

          <!-- debut logo -->
          <!-- <div class="pull-left" v-if="!admin">
            <span class="cursor-p" @click="next('/accueil', 0)">
              <i><img src="logo.png" alt="SD" class="img-fluid sidebar-logo ml-5 mb-1"/></i>
            </span>
          </div> -->
          <!-- fin logo -->

          <!-- debut centre -->
          <div class="d-flex justify-content-around">
            <div class="mx-auto">
              <strong >Bienvenue</strong>
            </div>
            <!-- 
            <span @click="next('/articles', 1)" :class="1==active ? 'passive-active':'passive'">
              <i class="fa fa-shopping-bag"></i>
              <span class="hider ml-2">Articles</span>
            </span>  
            <span @click="next('/em', 2)" :class="active==2? 'passive-active':'passive'">
              <i class="fa fa-users"></i>
              <span class="hider ml-2">Devenir membre</span>
            </span> -->
          </div>
          <!-- fin centre -->

          <!-- debut droite -->
          <div class="mr-5">
            <!-- 
            <span @click="next('/about', 3)" :class="active==3 ? 'passive-active':'passive'">
              <i class="fa fa-info-circle"></i>
              <span class="hider ml-2">A propos de nous</span>
            </span> -->
            <span @click="next('/login', 4)"
              :class="4==active ? 'passive-active':'passive'" v-if="!connected && !admin">
              <!-- <i class="fa fa-user"></i> -->
              <span class="hider">Se connecter</span>
            </span>
            <span @click="next('/register', 5)" :class="5==active ? 'passive-active':'passive'" 
              v-if="!connected && !admin">
              <!-- <i class="fa fa-user"></i> -->
              <span class="hider">S'inscrire</span>
            </span>
          </div>
          <!-- <span class="passive" @click="yes = !yes" v-if="!connected">
            <i class="fa fa-user"></i>
            <span class="hider">Mon compte</span>
          </span>-->
          <!-- icone -->
          <span class="header-links" v-if="connected">
            <div class="d-flex">
              <div class="pr-1 mr-3"  @click="userDetails(userId)" >
                <div class="username">{{fullname}}</div>
                <div class="userrole">{{role}}</div>
              </div>
              <div>
                <i @click="logout" class="fa fa-sign-out icon-size"></i>
              </div>
            </div>
          </span>
          <!-- fin droite -->
        </div>
        <div :class="admin? 'mh-100 px-1 py-1 overflow-y-auto': 'minh px-1 py-1 backG overflow-y-au to'">
          <slot></slot>
          <div v-if="yes" class="col-sm">
            <div class="alert m-1 col-sm-5">
              <div class="popup col-sm">
                <v-flex class="pos col-sm-4">
                  <div @click="yes = !yes" class="pull-right">
                    <i class="fa fa-close my-auto afh"></i>
                  </div>
                  <Popup />
                </v-flex>
              </div>
            </div>
          </div>
          <br />
          <br />
        </div>
        

        <footer v-if="!connected" class="footer d-flex align-items-end" style="width:100%;">
        <div class="container-fluid">
          <nav class="float-left">
            <ul>
              <li>
                <a href="https://www.creative-tim.com">
                  Creative Tim
                </a>

              </li>
              <li>
                <a href="https://creative-tim.com/presentation">
                  About Us
                </a>
              </li>
              <li>
                <a href="http://blog.creative-tim.com">
                  Blog
                </a>
              </li>
              <li>
                <a href="https://www.creative-tim.com/license">
                  Licenses
                </a>
              </li>
            </ul>
          </nav>
          <div class="copyright float-right">                      
            2021 <i class="material-icons">favorite</i> par
            <a href="https://www.creative-tim.com" target="_blank"> CFA Location</a>.
          </div>
        </div>
      </footer>
      
    </div>
  
</div>
</template>



<script>
import menuLinks from "../data/menu";
import Popup from "./popup";
import Footer from "./Footer";

export default {
  components: { Popup, Footer },
  name: "dashboard-layout",
  data() {
    return {
      childLinks: [],
      subpanelVisible: false,

      connected: false,
      admin: false,
      userDatas: '',
      userId: "",
      role: "",
      yes: false,
      info: false,
      active: 0,
      accessLink: false,
      showSideBar: false, 
    };
  },
  computed: {
    fullname: function () {
      var adminInfo = localStorage.getItem("adminInfo");
      try {
        adminInfo = JSON.parse(adminInfo);
        if (adminInfo.fullname) {
          return adminInfo.fullname;
        } 
        return adminInfo.name;
      } catch (error) {
        return "";
      }
    },
    userEmail: function () {
      var adminInfo = localStorage.getItem("adminInfo");
      try {
        adminInfo = JSON.parse(adminInfo);
        return adminInfo.email;
      } catch (error) {
        return "local@achatrapide.com";
      }
    },
    links: function () {
      return this.$store.getters.adminRole
        ? menuLinks[this.$store.getters.adminRole]
        : [];
    },
  },
  props: ["title"],
  mounted() {
    this.userDatas = JSON.parse(localStorage.getItem("adminInfo"))
    this.role = localStorage.getItem("adminRole")
    this.init();
    this.active = localStorage.getItem("active");
  },
  methods: {
    init() {
      if (localStorage.getItem("token")) {
        this.connected = true;

        if (this.role === "admin"){
          this.role = "Administrateur";
          this.showSideBar = true;
        }
        if (this.role === "agence"){
          this.role = "Agence";
          this.showSideBar = true;
        }
        if (this.role === "client"){
          this.role = "Client"
        }
        if (this.userDatas.active === false){
          console.log(this.userDatas.active)
          this.accessLink = !this.accessLink;
        }
      }
    },
    isActive: function (routeBase) {
      const base = this.$route.fullPath.split("/");
      if (base && base[1] === routeBase) {
        return "router-link-exact-active router-link-active";
      } else {
        return "";
      }
    },
    logout() {
      let datas = {
        admin : localStorage.getItem('adminId'),

        message: 'logout',
        date: new Date(),
        position : {
          longitude: 0, latitude: 0,
        },
      }
      navigator.geolocation.getCurrentPosition(position => {
        datas.position.longitude = position.coords.longitude,
        datas.position.latitude = position.coords.latitude
      });
      console.log('datas: ',datas)
      this.$service.createWithoutAuth("historiques", datas, (err, data) => {
        if (err) {
          this.errorMessage = err.data && err.data.message;
          return;
        }
        this.$store.commit("resetAdminInfo");
        localStorage.removeItem("adminId");
        localStorage.removeItem("adminInfo");
        localStorage.removeItem("token");
        this.$router.push({ path: "/login" });
        
      });
    },
    hideSubpanel() {
      this.subpanelVisible = false;
      this.childLinks = [];
    },
    showSubpanel(link) {
      if (!link.children) {
        this.subpanelVisible = false;
        this.childLinks = [];
        return true;
      }
      this.childLinks = link.children;
      this.subpanelVisible = true;
      return false;
    },
    next(lien, i) {
      localStorage.setItem("active", i);
      this.$router.push({ path: lien });
    },
    userDetails(id){
      this.$router.push("/users/detail/"+id);
    }
  },
};
</script>

<style lang="scss" scoped>
$color1: rgba(228, 87, 46, 1);
$color2:  #6D071A;
$color4: rgb(234, 237, 237);

.avatar {
  vertical-align: middle;
  width: 50px;
  height: 50px;
  border-radius: 50%;
}


.wrapper {
  height: 100vh;
  height: 100%;
  display: flex;
  margin: 50px 0 0 0;
}

.sub-sidebar {
  position: fixed;
  left: 250px;
  z-index: 75;
}

.sidebar {
  min-width: 190px;
  height: auto;
  // display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: space-between;
  align-items: stretch;
  z-index: 99;
}

.side-close i {
  padding: 10px;
  font-size: 18px;
  cursor: pointer;
}

.logo-box {
  justify-content: center;
  padding: 19px;
  border-bottom: 1px solid rgba(255, 255, 255, 0.116);
}

.disabled {
    opacity: 0.5;
    pointer-events: none;
}

.logo-box span {
  font-size: 1.35rem;
  font-weight: 500;
  color: $color1;
  line-height: 1.1;
}

.sidebar-logo {
  width: 130px;
}

.sidebare-logo {
  display: none;
}

.separator-line {
  width: 85px;
  background-color: #72a8d0;
  margin-top: 9px;
  margin-bottom: 13px;
}

.side-menu .side-menu-link {
  display: block;
  color: #fff;
  cursor: pointer;
  background-color: transparent;
  padding: 16px 25px;
}

.side-menu .side-menu-link:hover {
  text-decoration: none;
  background-color: darken($color2, 10%);
  color: white;
}

.side-menu .side-menu-link.router-link-active,
.side-menu .side-menu-link.router-link-exact-active,
.side-menu .side-menu-link:active {
  text-decoration: none;
  background-color: darken($color2, 15%);
  color: white;
}

.side-menu .side-menu-link i {
  margin-right: 15px;
  width: 20px;
  text-align: center;
}

.navtop {
  display: flex;
  justify-content: space-between;
  align-items: center;
  background-color: #fff;
  // box-shadow: 0 6px 22px rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
  padding: 10px 16px;
  // position: fixed;
  width: 100%;
}


.overflow-y-auto {
  overflow-y: scroll;
  // background-color: rgb(245, 245, 245);
}

.pb-max {
  padding-bottom: 80px;
}

.side-menu-linkInActive {
  text-decoration: none;
  display: block;
  padding: 10px;
  color: white;
  cursor: pointer;
  margin-right: -10px;
}

.side-menu-linkInActive:hover {
  text-decoration: none;
  background-color: #043d5c;
  color: white;
  margin-right: -10px;
}

.side-menu-linkInActive i {
  margin-right: 15px;
  width: 20px;
  text-align: center;
}

.panel-footer {
  text-align: center;
}

.panel-footer a {
  color: white;
}

.panel {
  background: transparent
    linear-gradient(180deg, darken($color2, 5%) 20%, darken($color2, 20%) 80%)
    0% 0% no-repeat padding-box;
  color: white;
}

.my-logo {
  text-align: center;
  text-align: center;
  padding: 8px 16px;
  width: 50px;
  height: 50px;
  border-radius: 6px;
  background: transparent linear-gradient(316deg, #eaf2ea 0%, #6c9698 100%) 0%
    0% no-repeat padding-box;
  border: 0.5px solid #caced5;
}

.icon-notif {
  color: #888888;
}

.logo-ecole {
  width: 20px;
  font-size: 15px;
  word-break: break-word;
  line-height: 1.1;
}

.logo-user {
  width: 38px;
  height: 38px;
  padding-top: 3px;
}

.school-name {
  font-size: 18px;
  font-weight: bold;
  line-height: 22px;
}

.school-year {
  font-size: 11px;
}

.username {
  font-weight: bold;
  font-size: 16px;
  text-align: right;
}

.userrole {
  font-size: 12px;
  text-align: right;
}

.header-links {
  color: #888888;
  margin: 4px;
}

.mainmenu-area {
  background: none repeat scroll 0 0 #fbfbfb;
  font-family: "Roboto Condensed", sans-serif;
  text-transform: uppercase;
  width: 100%;
  height: justify;
  z-index: 999;
  background-color: #fbfbfb;
}

.mainmenu-area span {
  color: #6e6a6a;
  font-size: 14px;
  padding: 14px;
}

.mainmenu-area span.active,
.mainmenu-area span:hover {
  background: #5a88ca;
  color: #fff;
}
.mainmenu-area span:focus {
  color: #fff;
}

@media only screen and (min-width: 768px) and (max-width: 991px) {
  .user-menu,
  .header-right ul.list-inline {
    text-align: center;
  }
}

.popup {
  background-color: #f1f1f1;
  border-radius: 10px;
  box-shadow: 0 6px 20px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
}

.pos {
  position: relative;
  justify-content: center;
  text-align: center;
}

.alert {
  position: fixed;
  margin-left: 30%;
  top: 45%;
  left: 50%;
  transform: translate(-50%, -50%);
}

.search-height {
  width: 100%;
  border-color: #fff;
  border-width: 1px;
}
.afh:hover {
  cursor: pointer;
}

.search {
  width: auto;
  border: 2px solid #f4f4f4;
  background-color: #f7910b;
  border-radius: 8px;
  padding: 2px;
}

input[type="searching"] {
  width: 60%;
  border: 2px solid #f4f4f4;
  height: 34px;
  border-radius: 10px;
  box-sizing: border-box;
  font-size: 16px;
  background-color: #ffffff;
  background-image: url("../../public/assets/images/sic.png");
  background-size: 22px;
  background-position: 10px 5px;
  background-repeat: no-repeat;
  padding: 10px 20px 10px 40px;
  -webkit-transition: width 0.4s ease-in-out;
  transition: width 0.4s ease-in-out;
}

input[type="searching"]:focus,
input[type="searching"]:hover {
  background-color: #f4f4f4;
  border: 2px solid #f7910b;
  width: 90%;
}


.icon-size {
  font-size: 225%;
  padding: 4px;
}

@media screen and (min-width: 180px) and (max-width: 650px) and (max-width: 1120px) {
  .hider {
    display: none;
  }

  .beaud {
    background-size: cover;
    background-image: url("../../public/assets/images/favicon.png");
  }


  .sidebar-logo {
    display: none;
  }

  .sidebare-logo {
    display: inline;
    width: 26px;
    height: 20px;
    margin-top: 8px;
  }

  .username { 
    font-size: 9px;
    // width: 18px;
  }

  .userrole {
    font-size: 8px;
    text-align: right;
  }

  .icon-size {
    font-size: 140%;
    padding: 3px;
    vertical-align: middle;
  }

  .sidebar {
    min-width: 64px;
    height: auto;
  }  
}


.header-links-size {
  font-size: 120%;
  margin-left: 6px;
}
// input[type=search]:focus { width: 82%;}

.minh {
  min-height: 86%;
  overflow-x: hidden;
  background-color: rgb(234, 237, 237);
  margin: 4px auto 0;
  position: relative;
  // padding-top: 20px;
}
</style>
